## sagemath 8.2

=== sage/Makefile ===
# Main Makefile for Sage.

# The default target ("all") builds Sage and the whole (HTML) documentation.
#
# Target "build" just builds Sage.
#
# See below for targets to build the documentation in other formats,
# to run various types of test suites, and to remove parts of the build etc.

default: all

build: all-build

# The --stop flag below is just a random flag to induce graceful
# breakage with non-GNU versions of make.
# See https://trac.sagemath.org/ticket/24617

# Defer unknown targets to build/make/Makefile
%::
	@if [ -x relocate-once.py ]; then ./relocate-once.py; fi
	$(MAKE) build/make/Makefile --stop
	+build/bin/sage-logger \
		"cd build/make && ./install '$@'" logs/install.log

# If configure was run before, rerun it with the old arguments.
# Otherwise, run configure with argument $PREREQ_OPTIONS.
build/make/Makefile: configure build/make/deps build/pkgs/*/*
	rm -f config.log
	mkdir -p logs/pkgs
	ln -s logs/pkgs/config.log config.log
	@if [ -x config.status ]; then \
		./config.status --recheck && ./config.status; \
	else \
		./configure $$PREREQ_OPTIONS; \
	fi || ( \
		if [ "x$$SAGE_PORT" = x ]; then \
			echo "If you would like to try to build Sage anyway (to help porting),"; \
			echo "export the variable 'SAGE_PORT' to something non-empty."; \
			exit 1; \
		else \
			echo "Since 'SAGE_PORT' is set, we will try to build anyway."; \
		fi; )

# This is used to monitor progress towards Python 3 and prevent
# regressions. The target "build" should be upgraded to reflect the
# level of Python 3 support that is known to work.
buildbot-python3: configure
	./configure --with-python=3
	$(MAKE) build

# Preemptively download all standard upstream source tarballs.
download:
	export SAGE_ROOT=$$(pwd) && \
	export PATH=$$SAGE_ROOT/src/bin:$$PATH && \
	./src/bin/sage-download-upstream

dist: build/make/Makefile
	./sage --sdist

# ssl: build Sage, and also install pyOpenSSL. This is necessary for
# running the secure notebook. This make target requires internet
# access. Note that this requires that your system have OpenSSL
# libraries and headers installed. See README.txt for more
# information.
ssl: all
	./sage -i pyopenssl

misc-clean:
	@echo "Deleting miscellaneous artifacts generated by build system ..."
	rm -rf logs
	rm -rf dist
	rm -rf tmp
	rm -f aclocal.m4 config.log config.status confcache
	rm -rf autom4te.cache
	rm -f build/make/Makefile build/make/Makefile-auto
	rm -f .BUILDSTART

bdist-clean: clean
	$(MAKE) misc-clean

distclean: build-clean
	$(MAKE) misc-clean
	@echo "Deleting all remaining output from build system ..."
	rm -rf local
	rm -f src/bin/sage-env-config

# Delete all auto-generated files which are distributed as part of the
# source tarball
bootstrap-clean:
	rm -rf config configure build/make/Makefile-auto.in

# Remove absolutely everything which isn't part of the git repo
maintainer-clean: distclean bootstrap-clean
	rm -rf upstream

micro_release: bdist-clean sagelib-clean
	@echo "Stripping binaries ..."
	LC_ALL=C find local/lib local/bin -type f -exec strip '{}' ';' 2>&1 | grep -v "File format not recognized" |  grep -v "File truncated" || true

TESTALL = ./sage -t --all
PTESTALL = ./sage -t -p --all

test: all
	$(TESTALL) --logfile=logs/test.log

check: test

testall: all
	$(TESTALL) --optional=sage,optional,external --logfile=logs/testall.log

testlong: all
	$(TESTALL) --long --logfile=logs/testlong.log

testalllong: all
	$(TESTALL) --long --optional=sage,optional,external --logfile=logs/testalllong.log

ptest: all
	$(PTESTALL) --logfile=logs/ptest.log

ptestall: all
	$(PTESTALL) --optional=sage,optional,external --logfile=logs/ptestall.log

ptestlong: all
	$(PTESTALL) --long --logfile=logs/ptestlong.log

ptestalllong: all
	$(PTESTALL) --long --optional=sage,optional,external --logfile=logs/ptestalllong.log

testoptional: all
	$(TESTALL) --optional=sage,optional --logfile=logs/testoptional.log

testoptionallong: all
	$(TESTALL) --long --optional=sage,optional --logfile=logs/testoptionallong.log

ptestoptional: all
	$(PTESTALL) --optional=sage,optional --logfile=logs/ptestoptional.log

ptestoptionallong: all
	$(PTESTALL) --long --optional=sage,optional --logfile=logs/ptestoptionallong.log

configure: configure.ac src/bin/sage-version.sh m4/*.m4
	./bootstrap -d

install: all
	@echo "******************************************************************"
	@echo "The '$@' target is a no-op; 'make' already does 'make install'"
	@echo "You can change the install prefix from its default"
	@echo "(the subdirectory 'local') by using ./configure --prefix=PREFIX"
	@echo "You can also consider using the binary packaging scripts"
	@echo "from https://github.com/sagemath/binary-pkg"
	@echo "******************************************************************"

list:
	@$(MAKE) --silent build/make/Makefile >&2
	@$(MAKE) --silent -f build/make/Makefile SAGE_SPKG_INST=local $@

.PHONY: default build install micro_release \
	misc-clean bdist-clean distclean bootstrap-clean maintainer-clean \
	test check testoptional testall testlong testoptionallong testallong \
	ptest ptestoptional ptestall ptestlong ptestoptionallong ptestallong \
	buildbot-python3 list

=== sage/src/mac-app/Makefile ===
# Makefile for building the Mac App
#
# This assumes that you have already built Sage. This Makefile then
# compiles the Mac App UI and combines it with the existing Sage
# install into a DMG file.
#
# The resulting DMG is as relocatable as the original Sage install,
# that is, not at all by default. It will contain paths pointing to
# the Sage tree that you started with (OK if you are only debugging
# the Mac App, just don't delete the original Sage directory tree).
#
# To build a relocatable Sage binary you have to use
# https://github.com/sagemath/binary-pkg


ifdef SAGE_ROOT
    $(error This makefile must be run outside of a sage shell)
endif

SAGE_ROOT:=$(shell cd ../.. && pwd)

ifndef SAGE_VERSION
    SAGE_VERSION:=$(shell source ../bin/sage-version.sh && echo $$SAGE_VERSION)
endif

# Meaningful values, on Intel, are "i386" and "x86_64". To prepare a
# 64-bit binary distribution on an older 64-bit OSX machine that boots
# into a 32-bit system, one would set SAGE_APP_TARGET_ARCH=x86_64
ifndef SAGE_APP_TARGET_ARCH
    SAGE_APP_TARGET_ARCH:=$(shell uname -m)
endif

OSX_VERSION:=$(shell sw_vers -productVersion)

TARGET:=sage-$(SAGE_VERSION)-OSX_$(OSX_VERSION)_$(SAGE_APP_TARGET_ARCH)
APP_NAME:=SageMath-$(SAGE_VERSION).app
APP:=$(TARGET)/$(APP_NAME)
DMG:=$(TARGET).app.dmg

CONFIGURATION=Debug
SDKROOT=

SOURCE=*.h *.m

default: $(DMG)
app: $(APP)/Contents/Resources/sage

# Display the variables
debug:
	@echo SAGE_ROOT=$(SAGE_ROOT)
	@echo SAGE_VERSION=$(SAGE_VERSION)
	@echo OSX_VERSION=$(OSX_VERSION)
	@echo SAGE_APP_TARGET_ARCH=$(SAGE_APP_TARGET_ARCH)
	@echo CONFIGURATION=$(CONFIGURATION)
	@echo APP=$(APP)

# Build the Mac App UI binary (not: Sage itself)
$(APP): $(SOURCE)
	mkdir -p $(TARGET)
	xcodebuild -target Sage -configuration $(CONFIGURATION) \
	    ARCHS=$(SAGE_APP_TARGET_ARCH) \
	    ONLY_ACTIVE_ARCH=NO \
	    SDKROOT=$(SDKROOT)
	mkdir -p $(APP)
	cp -pRL build/$(CONFIGURATION)/Sage.app/ $(APP)
	@# Info.plist is a binary plist, so convert it for processing with sed.
	@# I would just change it to be an xml plist, but xcode changes it back.
	plutil -convert xml1 $(APP)/Contents/Info.plist
	sed -i '' "s/SAGE_VERSION/$(SAGE_VERSION)/" $(APP)/Contents/Info.plist

# Copy Sage into the App directory structure
$(APP)/Contents/Resources/sage: $(APP)
	mkdir -p $(APP)/Contents/Resources/sage
	rsync -av --progress \
	    $(SAGE_ROOT)/ $@ \
	    --exclude .git/ \
	    --exclude upstream/ \
	    --exclude src/mac-app/build \
	    --exclude src/mac-app/$(TARGET) \
	    --exclude src/mac-app/$(DMG) \
	    --exclude src/mac-app/tmp-$(DMG)
	@# We touch the director here so that we don't keep rsyncing just
	@# because $(APP) is newer than (the rsync preserves time)
	test -d $@ && touch $@

# The background image for the DMG.
# It contains the arrow pointing from the .app to the Applications
# folder.
#
# The background image should be at 72dpi. if a different resolution is
# set in the metadata, Finder produces weird results.
#
$(TARGET)/.background.png: sage-dmg-background.png
	cp sage-dmg-background.png $(TARGET)/.background.png

# Link to Applications
$(TARGET)/Applications:
	rm -f $(TARGET)/Applications
	ln -s /Applications/ $(TARGET)/Applications

# Add the readme file
$(TARGET)/README.txt: $(SAGE_ROOT)/src/bin/sage-README-osx.txt
	cp $^ $@

non_app_files: $(TARGET)/README.txt $(TARGET)/Applications

sage_symlink: $(APP)/Contents/Resources/sage
	rm -f $(APP)/sage
	ln -s Contents/Resources/sage/sage $(APP)/sage

# The arrangement of the icons and the "alias" or "bookmark" for the
# background image are stored in a .DS_Store file.
# The .DS_Store file does not store the background image by relative path,
# but by "alias" or "bookmark" which contains the volume name as well - so
# we cannot just generate the .DS_Store once and for all and copy it from
# version to version since the volume name contains the version.
$(TARGET)/.DS_Store: tools/createDSStore/createDSStore.py
	@# On some old Mac OS X, createDSStore fails when there already
	@# is an existing file
	rm -f $(TARGET)/.DS_Store
	tools/createDSStore/createDSStore.py $(TARGET) $(TARGET) $(APP_NAME)

# Dependencies need to be in that order because non_app_files
# needs the directory created by $(APP)/Contents/Resources/sage
$(DMG): $(APP)/Contents/Resources/sage sage_symlink $(TARGET)/.background.png $(TARGET)/.DS_Store non_app_files 
	hdiutil create -srcfolder $(TARGET) -volname $(TARGET) -format UDBZ $(DMG)

###############################################################################
# Alternative method to create the .dmg
# 
# The .DS_Store file created above with createDSStore doesn't display correctly
# on some versions of Mac OS X (it appears the first releases of Mac OS 10.12),
# see tickets 22739 and 23426.
# The reason is that Finder introduced a new way ("bookmark") of storing the
# location of the background image in the .DS_Store file and bugs in reading the
# old format ("alias"), see https://bitbucket.org/al45tair/ds_store/issues/7 
# which also describes how createDSStore could be updated to write a "bookmark"
# as well.
# 
# An alternative method is to use AppleScript. Unfortunately, this requires
# generating a temporary read-write disk image, mounting it, then calling the
# AppleScript to set the background image and finally compressing the disk
# image.
#
# To experiment with the alternative method, call alt-$(DMG).

$(TARGET)/.background/sage.png: sage-dmg-background.png
	mkdir -p $(TARGET)/.background
	cp sage-dmg-background.png $(TARGET)/.background/sage.png

# The temporary read-write disk image.
#
# Dependencies need to be in that order because non_app_files
# needs the directory created by $(APP)/Contents/Resources/sage
tmp-$(DMG): $(APP)/Contents/Resources/sage sage_symlink $(TARGET)/.background/sage.png non_app_files
	@# Create initial DMG
	hdiutil create -srcfolder $(TARGET) -volname $(TARGET) -format UDRW tmp-$(DMG)

	@# Mount it so that we can run the Apple Script file on it
	@# to arrange the icons and set the background image
	mkdir -p mnt
	hdiutil attach tmp-$(DMG) -mountpoint mnt
	osascript tools/arrangeIcons.applescript mnt $(APP_NAME)
	hdiutil detach mnt

# Compress the temporary DMG
alt-$(DMG): tmp-$(DMG)
	hdiutil convert -format UDBZ -o alt-$(DMG) tmp-$(DMG)	

#
#
# End of alternative method
###############################################################################

.PHONY: clean default debug app non_app_files sage_symlink

clean:
	rm -rf $(TARGET) build $(DMG) tmp-$(DMG) mnt

=== debian/changelog ===
sagemath (8.2-5ubuntu1) cosmic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Use gdb instead of gdb-python2 as a build dependency.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 02 Jul 2018 16:14:04 +0200

sagemath (8.2-5) unstable; urgency=medium

  * New patch d1-remove-sage-python23.patch. (Closes: #902545)

 -- Tobias Hansen <thansen@debian.org>  Fri, 29 Jun 2018 12:12:45 +0200

sagemath (8.2-4) unstable; urgency=medium

  * Depend on libflint-arb-dev (>= 1:2.12).

 -- Tobias Hansen <thansen@debian.org>  Tue, 26 Jun 2018 18:00:34 +0200

sagemath (8.2-3) unstable; urgency=medium

  * Upload to unstable.
  * Update networkx patch.

 -- Tobias Hansen <thansen@debian.org>  Tue, 26 Jun 2018 12:01:13 +0200

sagemath (8.2-2) experimental; urgency=medium

  * New (Build-)Depends:
    - python-networkx (>= 2.1)
    - sympow (>= 1.023-9)
  * New patches:
    - u0-version-networkx-2.1.patch              #24374
      (Closes: #901532)

 -- Tobias Hansen <thansen@debian.org>  Fri, 22 Jun 2018 14:22:29 +0000

sagemath (8.2-1) experimental; urgency=medium

  * New upstream version.
  * New (Build-)Depends:
    - cython (>= 0.28.2)
    - fflas-ffpack (>= 2.3.2)
    - flint-arb (>= 2.12),
    - givaro (>= 4.0.4)
    - linbox (>= 1.5.2)
    - pynac (>= 0.7.19)
    - sphinx (>= 1.7)
    - python-numpy (>= 1:1.14)
    - python-sagenb (>= 1.0.1+ds1-5)
  * Version restrictions to use packages from unstable
    rather than experimental:
    - libec-dev (<< 20171219~)
    - libsingular4-dev (<< 1:4.1.1~)
  * Remove patches (applied upstream):
    - u0-version-matplotlib-2.1.0.patch          #23696
    - u0-version-mpfr-4.0.patch                  #24353
    - u1-version-ipython-5.4.patch               #24389
    - u1-version-giac-1.2.3.57.patch
  * New patches:
    - u0-version-numpy-1.14.3.patch              #25260
    - u0-version-pynac-0.7.19.patch              #24838
    - u0-version-sphinx-1.7.patch                #24935
    - d0-pari-2.9-revert-24531.patch
    - dt-version-ipywidgets-6-revert-23177.patch
  * Patches with non-trivial modifications:
    - d0-arb.patch
    - d0-pari-2.9-revert-23544.patch
    - d0-paths.patch
    - d1-sage-cli.patch
  * Increase the allowed test failures from 62 up to 70.

 -- Tobias Hansen <thansen@debian.org>  Wed, 06 Jun 2018 17:48:06 +0000

=== debian/control ===
## DO NOT EDIT debian/control directly, edit debian/control.in instead
Source: sagemath
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>,
           Julien Puydt <julien.puydt@laposte.net>,
           Jerome Benoit <calculus@rezozer.net>,
           Ximin Luo <infinity0@debian.org>
Standards-Version: 4.1.2
X-Python-Version: 2.7
Homepage: http://www.sagemath.org/
Vcs-Git: https://salsa.debian.org/science-team/sagemath.git
Vcs-Browser: https://salsa.debian.org/science-team/sagemath
Build-Depends:
 cysignals-tools (>= 1.2.0+ds-2) <!nodoc>,
 cython (>= 0.28.2),
 ecl (>= 16.1.2),
 ecl (<< 16.1.3),
 eclib-tools (>= 20170122),
 f2c,
 fflas-ffpack (>= 2.3.2),
 flintqs,
 gap-core (>= 4r8p6),
 gfan,
 gmp-ecm,
 ipython (>= 5.1.0-2),
 iso-codes,
 jmol (>= 14.6.4),
 lcalc (>= 1.23+dfsg-6),
 less,
 libcdd-tools (>= 094h),
 libjs-mathjax,
 libjs-three (>= 80),
 libsingular4 (>= 1:4.1.0-p3),
 libsingular4 (<< 1:4.1.1~),
 maxima-sage (>= 5.39.0),
 maxima-sage-doc (>= 5.39.0),
 maxima-sage-share (>= 5.39.0),
 nauty,
 octave,
 palp (>= 2.1-2),
 pari-doc (>= 2.9.0),
 pari-gp (>= 2.9.0),
 pari-galdata,
 pari-seadata,
 python,
 python3,
 python-alabaster,
 python-babel,
 python-backports-abc,
 python-backports.functools-lru-cache,
 python-backports-shutil-get-terminal-size,
 python-backports.ssl-match-hostname,
 python-brial (>= 1.0.1),
 python-configparser,
 python-crypto,
 python-cvxopt,
 python-cycler,
 python-cypari2 (>= 1.1.3),
 python-cysignals-pari (>= 1.6.4),
 python-decorator,
 python-docutils,
 python-enum34,
 python-flask,
 python-flask-autoindex,
 python-flask-babel,
 python-flask-oldsessions,
 python-flask-openid,
 python-flask-silk,
 python-fpylll (>= 0.3.0),
 python-functools32,
 python-future,
 python-gd,
 python-gnutls,
 python-imagesize,
 python-ipython-genutils,
 python-itsdangerous,
 python-jsonschema,
 python-matplotlib (>= 2.1),
 python-mistune,
 python-moinmoin,
 python-mpmath,
 python-networkx (>= 2.1),
 python-numpy (>= 1:1.14),
 python-openid,
 python-path,
 python-pathlib2,
 python-pexpect (>= 4.1),
 python-pickleshare,
 python-pil,
 python-pip,
 python-pkgconfig,
 python-ply,
 python-prompt-toolkit,
 python-psutil,
 python-ptyprocess,
 python-pygments,
 python-rpy2,
 python-sagenb (>= 1.0.1+ds1-5),
 python-sagenb-export (>= 3.2),
 python-scipy (>= 0.19.1),
 python-setuptools,
 python-setuptools-scm,
 python-simplegeneric,
 python-singledispatch,
 python-snowballstemmer,
 python-sphinx (>= 1.7),
 python-subprocess32,
 python-sympy,
 python-terminado,
 python-tk,
 python-tornado,
 python-traitlets,
 python-twisted,
 python-typing,
 python-tz,
 python-vcversioner,
 python-wcwidth,
 python-werkzeug,
 python-zmq,
 python-zope.interface,
 r-cran-lattice,
 r-base-core,
 rubiks,
 sagemath-database-conway-polynomials (>= 0.5-2),
 sagemath-database-elliptic-curves,
 sagemath-database-graphs,
 sagemath-database-mutually-combinatorial-designs,
 sagemath-database-polytopes,
 singular (>= 1:4.1.0-p3),
 singular (<< 1:4.1.1~),
 singular-doc (>= 1:4.1.0-p3),
 singular-doc (<< 1:4.1.1~),
 sqlite3,
 sympow (>= 1.023-9),
 tachyon,
 xcas,
 jupyter-client,
 jupyter-core,
 jupyter-nbextension-jupyter-js-widgets,
 python-ipykernel,
 python-ipywidgets (>= 6.0.0),
 python-nbconvert,
 python-nbformat,
 python-notebook (>= 4.2.3-3),
 autoconf,
 ccache <pkg.sagemath.ccache>,
 cython-dbg <pkg.sagemath.dbg>,
 debhelper (>= 10),
 dh-python (>= 2.20170125),
 dpkg-dev (>= 1.17.14),
 gdb,
 git,
 gnutls-dev,
 libc6-dbg <pkg.sagemath.dbg>,
 libgap-sage-dev (>= 4.8.6),
 libblas-dev,
 libboost-dev (>= 1.55),
 libbrial-dev (>= 1.0.1),
 libbrial-groebner-dev (>= 1.0.1),
 libcdd-dev (>= 094h),
 libcliquer-dev,
 libec-dev (>= 20171002),
 libec-dev (<< 20171219~),
 libecm-dev,
 libflint-arb-dev (>= 1:2.12),
 libflint-dev (>= 2.5.2-5),
 libfplll-dev (>= 5.2.0),
 libfreetype6-dev,
 libgc-dev,
 libgcrypt-dev,
 libgd-dev,
 libgf2x-dev (>= 1.2-4),
 libgiac-dev (>= 1.2.3.25+dfsg1-3),
 libgivaro-dev (>= 4.0.4),
 libglpk-dev,
 libgmp-dev (>= 2:5.1.2),
 libgpg-error-dev,
 libgsl-dev (>= 2.4+dfsg-5~),
 libiml-dev,
 liblapack-dev,
 liblfunction-dev,
 liblinboxsage-dev (>= 1.5.2-1~exp2),
 liblrcalc-dev (>= 1.2-2),
 libm4ri-dev (>= 20130416),
 libm4rie-dev (>= 20130416),
 libmpc-dev (>=1.0),
 libmpfi-dev,
 libmpfr-dev,
 libntl-dev (>= 9.9.1-2),
 libopenblas-dev (>= 0.2.19) [amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64] | libatlas-base-dev,
 libpari-dev (>= 2.9.0),
 libplanarity-dev,
 libpng-dev,
 libppl-dev (>= 1:1.1),
 libpynac-dev (>= 0.7.19),
 libratpoints-dev,
 libreadline-dev,
 librw-dev,
 libsingular4-dev (>= 1:4.1.0-p3),
 libsingular4-dev (<< 1:4.1.1~),
 libsqlite3-dev,
 libsymmetrica-dev,
 libzn-poly-dev,
 pkg-config,
 python-dev,
 python-dbg <pkg.sagemath.dbg>,
 python-cysignals-pari-dbgsym <pkg.sagemath.dbg>,
 python3-dev,
 r-base-dev,
 rdfind,
 scons,
 texlive-latex-base,
 zlib1g-dev,

Package: sagemath
Architecture: any
Multi-Arch: same
Description: Open Source Mathematical Software
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the main SageMath installation.
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends},
 cysignals-tools (>= 1.2.0+ds-2) <!nodoc>,
 cython (>= 0.28.2),
 ecl (>= 16.1.2),
 ecl (<< 16.1.3),
 eclib-tools (>= 20170122),
 f2c,
 fflas-ffpack (>= 2.3.2),
 flintqs,
 gap-core (>= 4r8p6),
 gfan,
 gmp-ecm,
 ipython (>= 5.1.0-2),
 iso-codes,
 jmol (>= 14.6.4),
 lcalc (>= 1.23+dfsg-6),
 less,
 libcdd-tools (>= 094h),
 libjs-mathjax,
 libjs-three (>= 80),
 libsingular4 (>= 1:4.1.0-p3),
 libsingular4 (<< 1:4.1.1~),
 maxima-sage (>= 5.39.0),
 maxima-sage-doc (>= 5.39.0),
 maxima-sage-share (>= 5.39.0),
 nauty,
 octave,
 palp (>= 2.1-2),
 pari-doc (>= 2.9.0),
 pari-gp (>= 2.9.0),
 pari-galdata,
 pari-seadata,
 python,
 python3,
 python-alabaster,
 python-babel,
 python-backports-abc,
 python-backports.functools-lru-cache,
 python-backports-shutil-get-terminal-size,
 python-backports.ssl-match-hostname,
 python-brial (>= 1.0.1),
 python-configparser,
 python-crypto,
 python-cvxopt,
 python-cycler,
 python-cypari2 (>= 1.1.3),
 python-cysignals-pari (>= 1.6.4),
 python-decorator,
 python-docutils,
 python-enum34,
 python-flask,
 python-flask-autoindex,
 python-flask-babel,
 python-flask-oldsessions,
 python-flask-openid,
 python-flask-silk,
 python-fpylll (>= 0.3.0),
 python-functools32,
 python-future,
 python-gd,
 python-gnutls,
 python-imagesize,
 python-ipython-genutils,
 python-itsdangerous,
 python-jsonschema,
 python-matplotlib (>= 2.1),
 python-mistune,
 python-moinmoin,
 python-mpmath,
 python-networkx (>= 2.1),
 python-numpy (>= 1:1.14),
 python-openid,
 python-path,
 python-pathlib2,
 python-pexpect (>= 4.1),
 python-pickleshare,
 python-pil,
 python-pip,
 python-pkgconfig,
 python-ply,
 python-prompt-toolkit,
 python-psutil,
 python-ptyprocess,
 python-pygments,
 python-rpy2,
 python-sagenb (>= 1.0.1+ds1-5),
 python-sagenb-export (>= 3.2),
 python-scipy (>= 0.19.1),
 python-setuptools,
 python-setuptools-scm,
 python-simplegeneric,
 python-singledispatch,
 python-snowballstemmer,
 python-sphinx (>= 1.7),
 python-subprocess32,
 python-sympy,
 python-terminado,
 python-tk,
 python-tornado,
 python-traitlets,
 python-twisted,
 python-typing,
 python-tz,
 python-vcversioner,
 python-wcwidth,
 python-werkzeug,
 python-zmq,
 python-zope.interface,
 r-cran-lattice,
 r-base-core,
 rubiks,
 sagemath-database-conway-polynomials (>= 0.5-2),
 sagemath-database-elliptic-curves,
 sagemath-database-graphs,
 sagemath-database-mutually-combinatorial-designs,
 sagemath-database-polytopes,
 singular (>= 1:4.1.0-p3),
 singular (<< 1:4.1.1~),
 singular-doc (>= 1:4.1.0-p3),
 singular-doc (<< 1:4.1.1~),
 sqlite3,
 sympow (>= 1.023-9),
 tachyon,
 xcas,
 sagemath-common (= ${source:Version})
Recommends:
 sagemath-doc-en (= ${source:Version}),
 sagemath-jupyter (= ${source:Version}),
 sagetex,
 texlive-latex-base
Suggests:
 dot2tex,
 gap-design,
 gap-factint,
 gap-grape,
 gap-guava,
 gap-laguna,
 gap-sonata,
 gap-toric

Package: sagemath-common
Architecture: all
Multi-Arch: foreign
Description: Open Source Mathematical Software - architecture-independent files
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the architecture-independent files of SageMath.
Depends: ${misc:Depends}, ${python:Depends}

Package: sagemath-jupyter
Architecture: all
Multi-Arch: foreign
Description: Open Source Mathematical Software - Jupyter kernel
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the Jupyter kernel of SageMath.
Depends: ${misc:Depends},
 jupyter-client,
 jupyter-core,
 jupyter-nbextension-jupyter-js-widgets,
 python-ipykernel,
 python-ipywidgets (>= 6.0.0),
 python-nbconvert,
 python-nbformat,
 python-notebook (>= 4.2.3-3),
 sagemath (>= ${source:Version}), sagemath (<< ${source:Version}.1~)

Package: sagemath-doc-ca
Architecture: all
Description: Open Source Mathematical Software - documentation (Catalan; Valencian)
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains documentation in Catalan; Valencian.
 .
 Note that the package for English documentation (sagemath-doc-en) contains far
 more documentation than any of the other languages. So if you're finding this
 package lacking in content, then you could try that one as well.
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}

Package: sagemath-doc-de
Architecture: all
Description: Open Source Mathematical Software - documentation (German)
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains documentation in German.
 .
 Note that the package for English documentation (sagemath-doc-en) contains far
 more documentation than any of the other languages. So if you're finding this
 package lacking in content, then you could try that one as well.
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}

Package: sagemath-doc-en
Architecture: all

## sagemath 8.3

=== sage/Makefile ===
--- 
+++ 
@@ -9,7 +9,18 @@
 
 default: all
 
-build: all-build
+all: base-toolchain
+	$(MAKE) all-start
+
+build: base-toolchain
+	$(MAKE) all-build
+
+start: base-toolchain
+	$(MAKE) build-start
+
+sageruntime: base-toolchain
+	$(MAKE) all-sageruntime
+
 
 # The --stop flag below is just a random flag to induce graceful
 # breakage with non-GNU versions of make.

=== debian/changelog ===
sagemath (8.3-4) unstable; urgency=medium

  * Install sage-python23. (Closes: #910940)
  * Remove d1-remove-sage-python23.patch.
  * Fix some lintian warnings.
  * Fix path to sage-version.sh in u1-scripts-dir.patch.

 -- Tobias Hansen <thansen@debian.org>  Sun, 14 Oct 2018 12:47:48 +0000

sagemath (8.3-3) unstable; urgency=medium

  * New (Build-)Depends:
    - singular (== 4.1.1-p2)
  * New patches:
    - u0-version-singular-4.1.1p2.patch
  * Remove patches (applied upstream):
    - u0-fix-dont-require-DISPLAY.patch          #22441
  * dt-more-fix-test-cases.patch:
    Disable a test in sage/src/sage/libs/pari/tests.py that sometimes
    hangs on ppc64el.

 -- Tobias Hansen <thansen@debian.org>  Sat, 06 Oct 2018 14:15:28 +0000

sagemath (8.3-2) unstable; urgency=medium

  * Remove dependency on backports.ssl-match-hostname. (Closes: #909975)
  * Remove patches:
    - d1-test-optional.patch

 -- Tobias Hansen <thansen@debian.org>  Mon, 01 Oct 2018 20:16:30 +0200

sagemath (8.3-1) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Hansen <thansen@debian.org>  Wed, 26 Sep 2018 18:44:43 +0000

sagemath (8.3-1~exp2) experimental; urgency=medium

  [ Julian Rüth ]
  * New patches:
    - u0-fix-symlink-sage-kernel-spec.patch      #25722

  [ Ximin Luo ]
  * New patches:
    - u2-version-r-3.5.1-incomplete.patch        #26185

  [ Tobias Hansen ]
  * Depend on python-stemmer to fix docbuild (see #907381).

 -- Tobias Hansen <thansen@debian.org>  Tue, 04 Sep 2018 20:24:14 +0000

sagemath (8.3-1~exp1) experimental; urgency=medium

  [ Julian Rüth ]
  * New upstream version.
  * New (Build-)Depends:
    - libflint-arb-dev (>= 1:2.13)
    - libfplll-dev (>= 5.2.1)
    - libpynac-dev (>= 0.7.22)
    - ipython (>= 5.5.0)
    - maxima-sage (>= 5.41.0)
    - python-fpylll (>= 0.4.1)
    - python-packaging
  * Remove patches (applied upstream):
    - u0-version-pynac-0.7.19.patch              #24838
    - u0-version-sphinx-1.7.patch                #24935
    - u0-version-pbori-boost1.62-hashes.patch    #22243
    - u0-version-networkx-2.1.patch              #24374
    - u0-reproducible-docs.patch                 #25093
    - u0-better-sphinx-failure-modes.patch       #25160, 25161
    - u1-version-cddlib-094h.patch               #25341

  [ Tobias Hansen ]
  * New (Build-)Depends:
    - gfan (>= 0.6.2)
    - libgiac-dev (>= 1.4.9.69)
    - pari (>= 2.11.0)
    - python-cypari2 (>= 1.2.1),
  * New patches:
    - u0-version-cypari2-1.2.1.patch             #25813
    - u0-version-pari-2.11.patch                 #25567
    - u0-version-arb-2.14.patch                  #25966
  * Removed patches (aaplied upstream):
    - u2-pari-stackwarn.patch                    #23263
    - d0-pari-2.9-revert-24531.patch
    - d0-pari-2.9-revert-23544.patch
  * Use atlas instead of openblas to work around crashes with openblas 0.3.2.

 -- Ximin Luo <infinity0@debian.org>  Sun, 12 Aug 2018 14:53:31 -0700

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,6 @@
            Jerome Benoit <calculus@rezozer.net>,
            Ximin Luo <infinity0@debian.org>
 Standards-Version: 4.1.2
-X-Python-Version: 2.7
 Homepage: http://www.sagemath.org/
 Vcs-Git: https://salsa.debian.org/science-team/sagemath.git
 Vcs-Browser: https://salsa.debian.org/science-team/sagemath
@@ -22,9 +21,9 @@
  fflas-ffpack (>= 2.3.2),
  flintqs,
  gap-core (>= 4r8p6),
- gfan,
+ gfan (>= 0.6.2),
  gmp-ecm,
- ipython (>= 5.1.0-2),
+ ipython (>= 5.5.0),
  iso-codes,
  jmol (>= 14.6.4),
  lcalc (>= 1.23+dfsg-6),
@@ -32,16 +31,16 @@
  libcdd-tools (>= 094h),
  libjs-mathjax,
  libjs-three (>= 80),
- libsingular4 (>= 1:4.1.0-p3),
- libsingular4 (<< 1:4.1.1~),
- maxima-sage (>= 5.39.0),
- maxima-sage-doc (>= 5.39.0),
- maxima-sage-share (>= 5.39.0),
+ libsingular4 (>= 1:4.1.1-p2),
+ libsingular4 (<< 1:4.1.1-p3+ds-1),
+ maxima-sage (>= 5.41.0),
+ maxima-sage-doc (>= 5.41.0),
+ maxima-sage-share (>= 5.41.0),
  nauty,
  octave,
  palp (>= 2.1-2),
- pari-doc (>= 2.9.0),
- pari-gp (>= 2.9.0),
+ pari-doc (>= 2.11.0),
+ pari-gp (>= 2.11.0),
  pari-galdata,
  pari-seadata,
  python,
@@ -51,13 +50,12 @@
  python-backports-abc,
  python-backports.functools-lru-cache,
  python-backports-shutil-get-terminal-size,
- python-backports.ssl-match-hostname,
  python-brial (>= 1.0.1),
  python-configparser,
  python-crypto,
  python-cvxopt,
  python-cycler,
- python-cypari2 (>= 1.1.3),
+ python-cypari2 (>= 1.2.1),
  python-cysignals-pari (>= 1.6.4),
  python-decorator,
  python-docutils,
@@ -68,7 +66,7 @@
  python-flask-oldsessions,
  python-flask-openid,
  python-flask-silk,
- python-fpylll (>= 0.3.0),
+ python-fpylll (>= 0.4.1),
  python-functools32,
  python-future,
  python-gd,
@@ -84,6 +82,7 @@
  python-networkx (>= 2.1),
  python-numpy (>= 1:1.14),
  python-openid,
+ python-packaging,
  python-path,
  python-pathlib2,
  python-pexpect (>= 4.1),
@@ -106,6 +105,7 @@
  python-singledispatch,
  python-snowballstemmer,
  python-sphinx (>= 1.7),
+ python-stemmer,
  python-subprocess32,
  python-sympy,
  python-terminado,
@@ -128,10 +128,10 @@
  sagemath-database-graphs,
  sagemath-database-mutually-combinatorial-designs,
  sagemath-database-polytopes,
- singular (>= 1:4.1.0-p3),
- singular (<< 1:4.1.1~),
- singular-doc (>= 1:4.1.0-p3),
- singular-doc (<< 1:4.1.1~),
+ singular (>= 1:4.1.1-p2),
+ singular (<< 1:4.1.1-p3+ds-1),
+ singular-doc (>= 1:4.1.1-p2),
+ singular-doc (<< 1:4.1.1-p3+ds-1),
  sqlite3,
  sympow (>= 1.023-9),
  tachyon,
@@ -150,7 +150,7 @@
  debhelper (>= 10),
  dh-python (>= 2.20170125),
  dpkg-dev (>= 1.17.14),
- gdb,
+ gdb-python2,
  git,
  gnutls-dev,
  libc6-dbg <pkg.sagemath.dbg>,
@@ -164,15 +164,15 @@
  libec-dev (>= 20171002),
  libec-dev (<< 20171219~),
  libecm-dev,
- libflint-arb-dev (>= 1:2.12),
+ libflint-arb-dev (>= 1:2.13),
  libflint-dev (>= 2.5.2-5),
- libfplll-dev (>= 5.2.0),
+ libfplll-dev (>= 5.2.1),
  libfreetype6-dev,
  libgc-dev,
  libgcrypt-dev,
  libgd-dev,
  libgf2x-dev (>= 1.2-4),
- libgiac-dev (>= 1.2.3.25+dfsg1-3),
+ libgiac-dev (>= 1.4.9.69),
  libgivaro-dev (>= 4.0.4),
  libglpk-dev,
  libgmp-dev (>= 2:5.1.2),
@@ -181,7 +181,7 @@
  libiml-dev,
  liblapack-dev,
  liblfunction-dev,
- liblinboxsage-dev (>= 1.5.2-1~exp2),
+ liblinboxsage-dev (>= 1.5.2-2),
  liblrcalc-dev (>= 1.2-2),
  libm4ri-dev (>= 20130416),
  libm4rie-dev (>= 20130416),
@@ -189,17 +189,19 @@
  libmpfi-dev,
  libmpfr-dev,
  libntl-dev (>= 9.9.1-2),
- libopenblas-dev (>= 0.2.19) [amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64] | libatlas-base-dev,
- libpari-dev (>= 2.9.0),
+# We use Atlas untill upstream has a patch for OpenBLAS 0.3.2, see https://trac.sagemath.org/ticket/26052
+# libopenblas-dev (>= 0.2.19) [amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64] | libatlas-base-dev,
+ libatlas-base-dev,
+ libpari-dev (>= 2.11.0),
  libplanarity-dev,
  libpng-dev,
  libppl-dev (>= 1:1.1),
- libpynac-dev (>= 0.7.19),
+ libpynac-dev (>= 0.7.22-3),
  libratpoints-dev,
  libreadline-dev,
  librw-dev,
- libsingular4-dev (>= 1:4.1.0-p3),
- libsingular4-dev (<< 1:4.1.1~),
+ libsingular4-dev (>= 1:4.1.1-p2),
+ libsingular4-dev (<< 1:4.1.1-p3+ds-1),
  libsqlite3-dev,
  libsymmetrica-dev,
  libzn-poly-dev,
@@ -238,9 +240,9 @@
  fflas-ffpack (>= 2.3.2),
  flintqs,
  gap-core (>= 4r8p6),
- gfan,
+ gfan (>= 0.6.2),
  gmp-ecm,
- ipython (>= 5.1.0-2),
+ ipython (>= 5.5.0),
  iso-codes,
  jmol (>= 14.6.4),
  lcalc (>= 1.23+dfsg-6),
@@ -248,16 +250,16 @@
  libcdd-tools (>= 094h),
  libjs-mathjax,
  libjs-three (>= 80),
- libsingular4 (>= 1:4.1.0-p3),
- libsingular4 (<< 1:4.1.1~),
- maxima-sage (>= 5.39.0),
- maxima-sage-doc (>= 5.39.0),
- maxima-sage-share (>= 5.39.0),
+ libsingular4 (>= 1:4.1.1-p2),
+ libsingular4 (<< 1:4.1.1-p3+ds-1),
+ maxima-sage (>= 5.41.0),
+ maxima-sage-doc (>= 5.41.0),
+ maxima-sage-share (>= 5.41.0),
  nauty,
  octave,
  palp (>= 2.1-2),
- pari-doc (>= 2.9.0),
- pari-gp (>= 2.9.0),
+ pari-doc (>= 2.11.0),
+ pari-gp (>= 2.11.0),
  pari-galdata,
  pari-seadata,
  python,
@@ -267,13 +269,12 @@
  python-backports-abc,
  python-backports.functools-lru-cache,
  python-backports-shutil-get-terminal-size,
- python-backports.ssl-match-hostname,
  python-brial (>= 1.0.1),
  python-configparser,
  python-crypto,
  python-cvxopt,
  python-cycler,
- python-cypari2 (>= 1.1.3),
+ python-cypari2 (>= 1.2.1),
  python-cysignals-pari (>= 1.6.4),
  python-decorator,
  python-docutils,
@@ -284,7 +285,7 @@
  python-flask-oldsessions,
  python-flask-openid,
  python-flask-silk,
- python-fpylll (>= 0.3.0),
+ python-fpylll (>= 0.4.1),
  python-functools32,
  python-future,
  python-gd,
@@ -300,6 +301,7 @@
  python-networkx (>= 2.1),
  python-numpy (>= 1:1.14),
  python-openid,
+ python-packaging,
  python-path,
  python-pathlib2,
  python-pexpect (>= 4.1),
@@ -322,6 +324,7 @@
  python-singledispatch,
  python-snowballstemmer,
  python-sphinx (>= 1.7),
+ python-stemmer,
  python-subprocess32,
  python-sympy,
  python-terminado,
@@ -344,10 +347,10 @@
  sagemath-database-graphs,
  sagemath-database-mutually-combinatorial-designs,
  sagemath-database-polytopes,
- singular (>= 1:4.1.0-p3),
- singular (<< 1:4.1.1~),
- singular-doc (>= 1:4.1.0-p3),
- singular-doc (<< 1:4.1.1~),
+ singular (>= 1:4.1.1-p2),
+ singular (<< 1:4.1.1-p3+ds-1),
+ singular-doc (>= 1:4.1.1-p2),
+ singular-doc (<< 1:4.1.1-p3+ds-1),
  sqlite3,
  sympow (>= 1.023-9),
  tachyon,
@@ -446,8 +449,3 @@
  Note that the package for English documentation (sagemath-doc-en) contains far
  more documentation than any of the other languages. So if you're finding this
  package lacking in content, then you could try that one as well.
-Depends: ${misc:Depends}, ${sphinxdoc:Depends}
-Built-Using: ${sphinxdoc:Built-Using}
-
-Package: sagemath-doc-en
-Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

#
# CONTENTS:
#
# 1. DEFINITIONS
# 2. GENERATE FILES
#    Targets to auto-generate files
# 3. PACKAGE BUILD
#    Mostly standard targets that are used during package build
# 4. TEST SUITE
# 5. MAINTAINER TARGETS
#    Convenience targets to be used by maintainers
#    Some are explained at https://wiki.debian.org/DebianScience/Sage
#

###############################################################################
# 1. DEFINITIONS
###############################################################################

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

MAX_TEST_FAILURES = 70
MAX_TEST_FAILURES_RERUN = $(shell expr 2 \* $(MAX_TEST_FAILURES))

# If we're doing a pre-release, then be less strict about test failures, etc
ifneq (,$(filter $(DEB_DISTRIBUTION),UNRELEASED unstable-sage))
is_prerelease = true
else
is_prerelease = false
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS = 1
endif

# Some buildds are a bit slow, see https://buildd.debian.org/status/logs.php?pkg=gcc-7 for a fuller list
ifeq (false,$(is_prerelease))
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf mips mipsel mips64el))
export SAGE_TIMEOUT_LONG = 7200
else
export SAGE_TIMEOUT_LONG = 3600
endif
endif

# Use ccache if pkg.sagemath.ccache build-profile is active.
# Your rebuilds will be *much quicker*.
ifneq (,$(filter pkg.sagemath.ccache,$(DEB_BUILD_PROFILES)))
export PATH := /usr/lib/ccache:$(PATH)
export CCACHE_DIR := $(CURDIR)/debian/ccache
export CCACHE_BASEDIR := $(CURDIR)/debian/build
$(shell mkdir -p "$(CCACHE_DIR)")
endif

ifeq (,$(filter pkg.sagemath.nolongcheck,$(DEB_BUILD_PROFILES)))
SAGE_TEST_FLAGS = --long
endif

export SAGE_LOCAL = $(CURDIR)/debian/build/usr
export PYTHONPATH = $(CURDIR)/debian/build/usr/lib/python2.7/dist-packages
export DOT_SAGE = $(CURDIR)/debian/test
export SAGE_SCRIPTS_DIR = $(CURDIR)/sage/src/bin

LANGS = $(shell cd sage/src/doc && find . -mindepth 1 -maxdepth 1 -type d | grep -v common | cut -b3- | LC_ALL=C.UTF-8 LANG=C.UTF-8 sort)
DOCS_INSTALL = $(LANGS:%=debian/sagemath-doc-%.install)
DOCS_CONTROL = $(LANGS:%=debian/sagemath-doc-%.control)
DOCS_DOC_BASE = $(LANGS:%=debian/sagemath-doc-%.doc-base)
DOCS_OVERRIDES = $(LANGS:%=debian/sagemath-doc-%.lintian-overrides)
DOCS_INSTALL_DIRS = $(LANGS:%=debian/sagemath-doc-%)

ifneq (1,$(TRY_AVOID_REBUILD))
REBUILD_RULES = debian/rules
endif

%:
	dh $@ --with=python2,sphinxdoc

###############################################################################
# 2. GENERATE FILES
###############################################################################

binary build clean install: debian/control

debian/control: debian/control.in $(DOCS_CONTROL)
	cat $^ > "$@"
	sed -i -e '/RUNTIME_DEPENDS/ {' -e 'r debian/control.runtime-depends' -e 'd' -e '}' "$@"
	sed -i -e '/JUPYTER_DEPENDS/ {' -e 'r debian/control.jupyter-depends' -e 'd' -e '}' "$@"

debian/sagemath-doc-%.control: debian/sagemath-doc-LANG.control.in $(REBUILD_RULES)
	sed -e "s/LANGUAGE/$$(debian/lang.py $*)/g" -e 's/LANG/$*/g' < "$<" > "$@"

debian/sagemath-doc-%.install: debian/sagemath-doc-LANG.install.in $(REBUILD_RULES)
	sed -e "s/LANGUAGE/$$(debian/lang.py $*)/g" -e 's/LANG/$*/g' < "$<" > "$@"

debian/sagemath-doc-en.doc-base: debian/sagemath-doc-LANG.doc-base.in $(REBUILD_RULES)
	sed -e "s/LANGUAGE/$$(debian/lang.py en)/g" -e 's/LANG/en/g' -e 's/SUBDIR//g' < "$<" > "$@"

debian/sagemath-doc-ca.doc-base: debian/sagemath-doc-LANG.doc-base.in $(REBUILD_RULES)
	sed -e "s/LANGUAGE/$$(debian/lang.py ca)/g" -e 's/LANG/ca/g' -e 's/SUBDIR/intro\//g' < "$<" > "$@"

debian/sagemath-doc-%.doc-base: debian/sagemath-doc-LANG.doc-base.in $(REBUILD_RULES)
	if [ "$*" = "hu" -o "$*" = "it" -o "$*" = "tr" ]; then \
		sed -e "s/LANGUAGE/$$(debian/lang.py $*)/g" -e 's/LANG/$*/g' -e 's/SUBDIR/a_tour_of_sage\//g' < "$<" > "$@"; \
	else \
		sed -e "s/LANGUAGE/$$(debian/lang.py $*)/g" -e 's/LANG/$*/g' -e 's/SUBDIR/tutorial\//g' < "$<" > "$@"; \
	fi

debian/sagemath-doc-%.lintian-overrides: debian/sagemath-doc-LANG.lintian-overrides.in \
  $(wildcard debian/sagemath-doc-%.lintian-overrides.in) $(REBUILD_RULES)
	sed -e "s/LANGUAGE/$$(debian/lang.py $*)/g" -e 's/LANG/$*/g' < "$<" > "$@"
	if [ -f "debian/sagemath-doc-$*.lintian-overrides.in" ]; then \
		sed -e "s/LANGUAGE/$$(debian/lang.py $*)/g" -e 's/LANG/$*/g' < "debian/sagemath-doc-$*.lintian-overrides.in" >> "$@"; \
	fi

../sagemath_$(DEB_VERSION_UPSTREAM).orig.tar.xz: .git/modules/sage/HEAD
	cd sage && git archive --prefix=sagemath_$(DEB_VERSION_UPSTREAM)/sage/ \
	  --format=tar HEAD | xz -zf > ../../sagemath_$(DEB_VERSION_UPSTREAM).orig.tar.xz

../sagemath_$(DEB_VERSION).dsc: distclean-sage distclean ../sagemath_$(DEB_VERSION_UPSTREAM).orig.tar.xz debian/control
	dpkg-buildpackage -nc -d -uc -us -S

###############################################################################
# 3. PACKAGE BUILD
###############################################################################

prune: debian/control
	cd debian/pruner && autoconf -I m4
	cd debian/pruner && ./configure --with-sage-root="$(CURDIR)/sage"
	cd sage && python ../debian/pruner/pruner.py || $(is_prerelease)
	touch prune

run_build = \
	MAKE='make -j$(NUMJOBS)' PREREQ_OPTIONS="--prefix=$(SAGE_LOCAL)" \
	  $(MAKE) --directory=sage

override_dh_auto_configure: prune

override_dh_auto_build-arch:
	$(run_build) build
	cd sage && src/bin/sage-starts

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(run_build) doc
endif

override_dh_auto_install:
	rm -rf debian/build/usr/var/tmp/sage/build
# We built .pyo to make the docbuild/tests go faster, but as per Debian policy
# we don't distribute them.
	find debian/build '(' -name '*.pyc' -o -name '*.pyo' ')' -delete
	rm -f debian/build/usr/bin/*.bat
	mkdir -p debian/tmp
	mv debian/build/* debian/tmp
	cp -f debian/adhoc/sage-env debian/tmp/usr/bin/
# Install sage-python23 which is required at runtime but located in build/bin.
	cp -f sage/build/bin/sage-python23  debian/tmp/usr/bin/
# Don't try to rmdir debian/build if it's a mountpoint, useful for doing builds in /run/shm
	mountpoint debian/build || rmdir debian/build

# If we see "nodoc", don't clean the docs. This allows us to rebuild just the
# non-docs without wiping away the docs we previously built, to save time.
override_dh_auto_clean:
ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_clean -Dsage -- -k clean sagelib-clean misc-clean bootstrap-clean || true
	rm -rf sage/local sage/upstream
else
	dh_auto_clean -Dsage -- maintainer-clean
endif

override_dh_install-indep: $(DOCS_INSTALL) $(DOCS_DOC_BASE) $(DOCS_OVERRIDES)
	dh_install --package sagemath-common -X.so
	dh_install --remaining-packages --list-missing
# Basic version of deduplicating the docs, for a much smaller install size.
# Upstream bug report is at https://trac.sagemath.org/ticket/22088
# Hard links do work in Debian packages, but only within packages.
	set -e; for d in $(DOCS_INSTALL_DIRS); do \
		rdfind -outputname /dev/null -makehardlinks true "$$d"; \
	done

override_dh_python2-arch:
	dh_python2
	dh_numpy --package sagemath # stop lintian complaining at us

override_dh_shlibdeps:
	dh_shlibdeps -l debian/tmp/usr/lib

override_dh_compress:
# We probably don't need to install the pickle/doctree files but let's exempt
# them from compression anyway for now, so the build goes quicker.
	dh_compress -X.pdf -X.pickle -X.doctree

override_dh_sphinxdoc:
# TODO: fix MathJax.js, Sage needs special treatment
# `man dh_sphinxdoc` says symlinking translations.js is not yet supported
# likewise, it seems not to recognise searchtools.js yet
	dh_sphinxdoc -XMathJax.js -Xtranslations.js -Xsearchtools.js

# If we see "nodoc", don't clean the docs. This allows us to rebuild just the
# non-docs without wiping away the docs we previously built, to save time.
ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
